    .586                                ; create 32 bit code
    .model  flat, stdcall               ; 32 bit memory model
    option  casemap:none                ; Case sensitive

    include \GeneSys\include\windows.inc
    include \GeneSys\include\user32.inc
    include \GeneSys\include\kernel32.inc
    include \GeneSys\include\shell32.inc

    include \GeneSys\macros\macros.asm

    includelib  \GeneSys\lib\user32.lib
    includelib  \GeneSys\lib\kernel32.lib
    includelib  \GeneSys\lib\shell32.lib

.DATA

gc_Title db 'Housekeeping 101',0

.DATA?

ALIGN 4
ls_Instance HINSTANCE ?

.CODE

CleanRecycle proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    invoke  SHAddToRecentDocs, SHARD_PATH, 0
    invoke  SHEmptyRecycleBin, NULL, NULL, SHERB_NOCONFIRMATION+SHERB_NOPROGRESSUI+SHERB_NOSOUND
    ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
CleanRecycle endp
;
;
MBI_Timer Proc th_Wnd:HWND, tu_Msg:UINT, tu_EventId:UINT, tt_Time:DWORD
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   Simulate pressing the OK button by sending a WM_QUIT message
    invoke  PostQuitMessage, 0
    ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MBI_Timer EndP
;
;
ShowMsgBox Proc tc_Text:LPSTR, tn_IconID:DWORD, tn_TimeOut:DWORD
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Local   ls_MBP:MSGBOXPARAMS
    Local   lu_TimerId:UINT
    Local   ls_MSG:MSG

    mov     ls_MBP.cbSize, SizeOf MSGBOXPARAMS
    m2m     ls_MBP.hwndOwner, NULL
    m2m     ls_MBP.hInstance, ls_Instance
    m2m     ls_MBP.lpszText, tc_Text
    m2m     ls_MBP.lpszCaption, offset gc_Title
    m2m     ls_MBP.dwStyle, tn_IconID
    invoke  SetTimer, NULL, 0, tn_TimeOut, offset MBI_Timer
    mov     lu_TimerId, eax
    invoke  MessageBoxIndirect, Addr ls_MBP
    invoke  KillTimer, NULL, lu_TimerId
;   Remove WM_QUIT message, so the application doesn't quit
;   It is not really necessary but the program is better understood this way
    invoke  PeekMessage, addr ls_MSG, NULL, WM_QUIT, WM_QUIT, PM_REMOVE
    ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ShowMsgBox EndP
;
;
Start:
    invoke GetModuleHandle, NULL
    mov ls_Instance, eax
    invoke  MessageBox, NULL, chr$("Empty the Recycle Bin?"), chr$("Housekeeping 101"), MB_YESNO or MB_ICONASTERISK
    .if eax==IDYES
      invoke  CleanRecycle
      invoke  ShowMsgBox, chr$("Finished"),MB_OK or MB_ICONINFORMATION, 3000
    .endif
    invoke  ExitProcess, NULL
;
;
    end     Start

